unit Unit1;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QComCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdFTP, QGrids, Math, QExtCtrls,
  IdAntiFreezeBase, IdAntiFreeze, QButtons, QMenus;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabFichier: TTabSheet;
    Label2: TLabel;
    fichier_lowell: TEdit;
    ButtonFileLowellSeek: TButton;
    ButtonCreeBaseLowell: TButton;
    Orbite: TTabSheet;
    Label1: TLabel;
    ButtonFTPLowell: TButton;
    Button4: TButton;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    l_compteur: TLabel;
    ScrollBar1: TScrollBar;
    StringGrid1: TStringGrid;
    SB_Min: TLabel;
    SB_Max: TLabel;
    SB_current: TLabel;
    Filtrage: TTabSheet;
    Label4: TLabel;
    ButtonAucunFiltre: TButton;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    RadioButtonHSup: TRadioButton;
    RadioButtonHInf: TRadioButton;
    FiltreH: TEdit;
    Label5: TLabel;
    CheckBoxH: TCheckBox;
    CheckBoxDiam: TCheckBox;
    GroupBox2: TGroupBox;
    RadioButtonDiamSup: TRadioButton;
    FiltreDiam: TEdit;
    RadioButtonInf: TRadioButton;
    CheckBoxIncl: TCheckBox;
    GroupBox3: TGroupBox;
    RadioButtonInclSup: TRadioButton;
    FiltreIncl: TEdit;
    RadioButtonInclInf: TRadioButton;
    CheckBoxExc: TCheckBox;
    GroupBox4: TGroupBox;
    RadioButtonExcSup: TRadioButton;
    FiltreExc: TEdit;
    RadioButtonExcInf: TRadioButton;
    CheckBoxDGA: TCheckBox;
    GroupBox5: TGroupBox;
    RadioButtonDGASup: TRadioButton;
    FiltreDGA: TEdit;
    RadioButtonGDAInf: TRadioButton;
    ButtonAppliquerFiltre: TButton;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Panel2: TPanel;
    RadioButtonATEN: TRadioButton;
    CheckBox1: TCheckBox;
    RadioButtonApollo: TRadioButton;
    RadioButtonAMOR: TRadioButton;
    RadioButtonMars: TRadioButton;
    TabSheet1: TTabSheet;
    Fichier_MPC: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    ButtonFileMPCSeek: TButton;
    ButtonCreeBaseMPC: TButton;
    ButtonHTTPMPC: TButton;
    ComboBox1: TComboBox;
    Button1: TButton;
    Shape1: TShape;
    LabelSelection: TLabel;
    Label13: TLabel;
    ScrollBar2: TScrollBar;
    ScrollBar3: TScrollBar;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    TabSheet2: TTabSheet;
    Label18: TLabel;
    LabelNom: TLabel;
    LabelNumero: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    LabelVRang: TLabel;
    LabelVNom: TLabel;
    LabelVNumero: TLabel;
    LabelVH: TLabel;
    LabelVBMV: TLabel;
    LabelVClassIRAS: TLabel;
    LabelVDiam: TLabel;
    LabelVAnomMoy: TLabel;
    Label37: TLabel;
    LabelVEpoque: TLabel;
    LabelVArgPer: TLabel;
    LabelVLongNod: TLabel;
    LabelVInclin: TLabel;
    LabelVDGA: TLabel;
    LabelVExcent: TLabel;
    LabelVCode1: TLabel;
    LabelVCode2: TLabel;
    LabelVCode4: TLabel;
    LabelVCode3: TLabel;
    LabelVCode5: TLabel;
    LabelVCode6: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Recherche: TTabSheet;
    Edit1: TEdit;
    Label42: TLabel;
    Label43: TLabel;
    Button2: TButton;
    LMessage: TLabel;
    LMessage2: TLabel;
    Label44: TLabel;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    BUp: TBitBtn;
    BDown: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    BitBtnSauveListe: TBitBtn;
    BitBtnEffaceListe: TBitBtn;
    Label45: TLabel;
    Label46: TLabel;
    BitBtn5: TBitBtn;
    PopupMenu1: TPopupMenu;
    PopupTable: TMenuItem;
    VoirElements1: TMenuItem;
    Label47: TLabel;
    StringGrid2: TStringGrid;
    TabSheet5: TTabSheet;
    Memo1: TMemo;
    Label48: TLabel;
    SaveDialog1: TSaveDialog;
    Label49: TLabel;
    Image1: TImage;
    PopupMenu2: TPopupMenu;
    Up1: TMenuItem;
    Effacer1: TMenuItem;
    Descendre1: TMenuItem;
    VoirElements2: TMenuItem;
    procedure Button4Click(Sender: TObject);
    procedure ButtonFileLowellSeekClick(Sender: TObject);
    procedure ButtonCreeBaseLowellClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ButtonAucunFiltreClick(Sender: TObject);
    procedure CheckBoxHClick(Sender: TObject);
    procedure SetAppliquerFiltre;
    procedure CheckBoxDiamClick(Sender: TObject);
    procedure CheckBoxInclClick(Sender: TObject);
    procedure CheckBoxExcClick(Sender: TObject);
    procedure CheckBoxDGAClick(Sender: TObject);
    procedure ButtonAppliquerFiltreClick(Sender: TObject);
    procedure Update_StringGrid1;
    procedure ButtonFileMPCSeekClick(Sender: TObject);
    procedure ButtonCreeBaseMPCClick(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure ButtonFTPLowellClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Mise_a_jour_detail(objet_selectionne : longint);
    procedure Recherche_asteroide(Cle : string;Taille : longint; var resultat : longint;
                              var trouve   : boolean);
    procedure VoirElements1Click(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PopupTableClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Ajout_objet(objet : longint);
    procedure BitBtnEffaceListeClick(Sender: TObject);
    procedure BitBtnSauveListeClick(Sender: TObject);
    procedure StringGrid2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Up1Click(Sender: TObject);
    procedure Descendre1Click(Sender: TObject);
    procedure Effacer1Click(Sender: TObject);
    procedure VoirElements2Click(Sender: TObject);
    procedure StringGrid2Click(Sender: TObject);
    procedure BUpClick(Sender: TObject);
    procedure BDownClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);

  private

    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

const
   max_liste = 500000;
type
{ Format FORTRAN du fichier astorb.dat :
A5,1X,A18,1X,A15,1X,A5,1X,F5.2,1X,A4,1X,A5,1X,A4, 1X,6I4,1X,
2I5,1X,I4,2I2.2,1X,3(F10.6,1X),F9.6,1X,F10.8, 1X,F12.8,1X,I4,2I2.2,1X,F7.2,1X,F8.2,1X,I4,2I2,3(1X,F7.2,1X,I4,2I2)
}
   T_orbite = record
      numero : string[6];
      nom : string[18];
      H : string[5];
      BMV : string[4];
      Diam : string[5];
      Iclass: string[4];
      Epoque : String[10];
      AnomMoy: string[10];
      ArgPer : string[10];
      LongNod :string[10];
      Inclin  :string[9];
      Excent  :string[10];
      DGA     :string[12];
      Code1,Code2,Code3,Code4,Code5,Code6 : string[4]
{
      DateComp : I4,2I2.2,1X
CEU    : F7.2,1X (current ephemeris uncertaincy)
CEUchg.: F8.2,1X
CEUdate: I4,2I2,
PEUdata: 3(1X,F7.2,1X,I4,2I2) (peak ephemeris uncertaincy
}

   end;
   P_orbite = ^T_orbite;
var
  Form1: TForm1;
  liste : array[1..max_liste] of P_orbite;
  liste_filtree : array[1..max_liste] of longint;
  taille_liste_filtree,taille_liste,stringGrid1_Debut,
  debut_actuel : longint;  { Rang de l'asteroide  la ligne 1 }
  selection_objet_selectionne_liste,objet_selectionne_liste,
  compteur_liste,objet_selectionne : longint;

implementation

uses Unit2, Tri;

var
   Table_tri      : P_Table;

{$R *.xfm}

procedure TForm1.Button4Click(Sender: TObject);
begin
   Dispose(Table_Tri);
   Close;
end;

procedure TForm1.ButtonFileLowellSeekClick(Sender: TObject);
begin
   Opendialog1.InitialDir:=ExtractFileDir(fichier_lowell.Text);
   if Opendialog1.Execute then
      If FileExists(Opendialog1.FileName) then
      begin
         fichier_lowell.Text:=Opendialog1.FileName;
         ButtonCreeBaseLowell.Enabled:=true;
      end
      else
      begin
         fichier_lowell.Text:='';
         ButtonCreeBaseLowell.Enabled:=false;
      end;
end;

procedure TForm1.Update_StringGrid1;
var
   li : longint;
   s  : string;
begin
   for li:=debut_actuel to min(1000,taille_liste_filtree-StringGrid1_debut+1) do
   begin
      Str(li,s);
      StringGrid1.Cells[ 0,li]:=s;
      StringGrid1.Cells[ 1,li]:=liste[liste_filtree[li]]^.numero;
      StringGrid1.Cells[ 2,li]:=liste[liste_filtree[li]]^.nom;
      StringGrid1.Cells[ 3,li]:=liste[liste_filtree[li]]^.H ;
      StringGrid1.Cells[ 4,li]:=liste[liste_filtree[li]]^.BMV ;
      StringGrid1.Cells[ 5,li]:=liste[liste_filtree[li]]^.Diam;
      StringGrid1.Cells[ 6,li]:=liste[liste_filtree[li]]^.Epoque ;
      StringGrid1.Cells[ 7,li]:=liste[liste_filtree[li]]^.AnomMoy;
      StringGrid1.Cells[ 8,li]:=liste[liste_filtree[li]]^.ArgPer;
      StringGrid1.Cells[ 9,li]:=liste[liste_filtree[li]]^.LongNod;
      StringGrid1.Cells[10,li]:=liste[liste_filtree[li]]^.Inclin;
      StringGrid1.Cells[11,li]:=liste[liste_filtree[li]]^.Excent ;
      StringGrid1.Cells[12,li]:=liste[liste_filtree[li]]^.DGA;
   end;
   StringGrid1.RowCount:=min(1000,taille_liste_filtree-StringGrid1_debut+1)+1;

end;


procedure TForm1.ButtonCreeBaseLowellClick(Sender: TObject);
var
   astorb : textfile;
   buffer : string;
   compteur : longint;
   s,s1,s2  : string;
begin
   If FileExists(Fichier_lowell.text) then
   begin
      AssignFile(astorb,Fichier_lowell.text);
      Reset(astorb);
      compteur:=0;
      LMessage.Caption:='Lecture du fichier base de Lowell';
      repeat
         readln(astorb,buffer);
         inc(compteur);
         new(liste[compteur]);
         with liste[compteur]^ do
         begin
            numero:=copy(buffer,1,6);
            str(compteur,s);
            nom:=copy(buffer,7,18);
            with Table_Tri[2*compteur-1] do
            begin
               rang:=compteur;
               Str(compteur,value);
            end;
            with Table_Tri[2*compteur] do
            begin
               rang:=compteur;
               value:=Trim(nom);
            end;
            H:=copy(buffer,42,5);
            BMV:=copy(buffer,54,4);
            diam:=copy(buffer,59,5);
            IClass:=copy(buffer,65,4);
            Code1:=copy(buffer,70,4);
            Code2:=copy(buffer,74,4);
            Code3:=copy(buffer,78,4);
            Code4:=copy(buffer,82,4);
            Code5:=copy(buffer,86,4);
            Code6:=copy(buffer,90,4);

            s1:=copy(buffer,106,4);
            s2:=copy(buffer,110,2);
            Epoque:=copy(buffer,112,2)+'/'+s2+'/'+s1;
            AnomMoy:=copy(buffer,115,10);
            ArgPer:=copy(buffer,126,10);
            LongNod:=copy(buffer,137,10);
            Inclin:= copy(buffer,148,9);
            Excent:= copy(buffer,158,10);
            DGA:=copy(buffer,168,12);
         end;
         Liste_Filtree[compteur]:=compteur;
      until eof(astorb);
      closefile(astorb);
      s:='';
      LMessage.Caption:='Tri des objets de la base de Lowell';

      SortTable(Table_Tri,2*compteur);
      LMessage.Caption:='Objets de la base de Lowell tris.';

      taille_liste:=compteur;
      taille_liste_filtree:=compteur;

      StringGrid1.RowCount:=1001;
      str(compteur,s);
      l_compteur.Caption:=s+' asteroides lus';
      SB_Max.Caption:=s;
      Orbite.TabVisible:=true;
      With Scrollbar1 do
      begin
         Max:=compteur;
         SmallChange:=1000;
      end;
      debut_actuel:=1;

      Update_StringGrid1;

      ButtonFileLowellSeek.Enabled:=false;
      ButtonCreeBaseLowell.Enabled:=false; { Ainsi, si le fichier est lu, on ne peut plus
                                  recrer la liste }
      ButtonFileMPCSeek.Enabled:=false;
      ButtonCreeBaseMPC.Enabled:=false;

      Orbite.Enabled:=true;
      Filtrage.Enabled:=true;
      StringGrid1.Visible:=true;

   end


{ Format FORTRAN du fichier astorb.dat :
Number : A5,1X
Nom    : A18,1X
O.comp.: A15,1X
H      : A5,1X
Slope  : F5.2,1X
B-V    : A4,1X
I diam : A5,1X
I class: A4, 1X,
type   : 6I4,1X,
O.Arc+NObs :2I5,1X,
Epoque : I4,2I2.2,1X,
AnomMoy,ArgPer,LongNod : 3(F10.6,1X),
Inclin.: F9.6,1X,
Excent.: F10.8, 1X,
DGA    : F12.8,1X
DateComp : I4,2I2.2,1X
CEU    : F7.2,1X (current ephemeris uncertaincy)
CEUchg.: F8.2,1X
CEUdate: I4,2I2,
PEUdata: 3(1X,F7.2,1X,I4,2I2) (peak ephemeris uncertaincy
}
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

   StringGrid1.Cells[ 0,0]:='#';
   StringGrid1.Cells[ 1,0]:='Numro';
   StringGrid1.Cells[ 2,0]:='Nom';
   StringGrid1.Cells[ 3,0]:='H';
   StringGrid1.Cells[ 4,0]:='B-V';
   StringGrid1.Cells[ 5,0]:='Diam';
   StringGrid1.Cells[ 6,0]:='Epoque';
   StringGrid1.Cells[ 7,0]:='Ano.Moy.';
   StringGrid1.Cells[ 8,0]:='Arg.Per.';
   StringGrid1.Cells[ 9,0]:='Long.Nd.';
   StringGrid1.Cells[10,0]:='i ()';
   StringGrid1.Cells[11,0]:='e';
   StringGrid1.Cells[12,0]:='a (UA)';
   StringGrid1.Cells[13,0]:='DateComp.';

   StringGrid1.ColWidths[2]:=150;
   StringGrid1.ColWidths[3]:=50;
   StringGrid1.ColWidths[4]:=50;
   StringGrid1.ColWidths[5]:=50;
   StringGrid1.ColWidths[6]:=90;
   StringGrid1.ColWidths[7]:=90;
   StringGrid1.ColWidths[8]:=90;
   StringGrid1.ColWidths[9]:=90;
   StringGrid1.ColWidths[10]:=90;
   StringGrid1.ColWidths[11]:=95;
   StringGrid1.ColWidths[12]:=100;
   StringGrid1.ColWidths[13]:=90;


   StringGrid2.Cells[ 0,0]:='#';
   StringGrid2.Cells[ 1,0]:='Numro';
   StringGrid2.Cells[ 2,0]:='Nom';
   StringGrid2.ColWidths[2]:=150;

   LMessage.Caption:='';
   Orbite.Enabled:=false;
   Filtrage.Enabled:=false;
   StringGrid1.Visible:=false;
   New(Table_tri);
   objet_selectionne_liste:=0;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
var
   s: string;
   li : longint;
begin
    StringGrid1_debut:=(scrollbar1.Position div 1000)*1000+1;
    str(StringGrid1_debut,s);

    SB_current.Caption:=s;

    if StringGrid1_debut<>debut_actuel then
    begin
       StringGrid1.RowCount:=min(1000,taille_liste_filtree-StringGrid1_debut+1)+1;
       for li:=1 to min(1000,taille_liste_filtree-StringGrid1_debut+1) do
       begin
         Str(StringGrid1_debut+li-1,s);
         StringGrid1.Cells[ 0,li]:=s;
         StringGrid1.Cells[ 1,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.numero;
         StringGrid1.Cells[ 2,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.nom;
         StringGrid1.Cells[ 3,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.H ;
         StringGrid1.Cells[ 4,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.BMV ;
         StringGrid1.Cells[ 5,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.Diam;
         StringGrid1.Cells[ 6,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.Epoque ;
         StringGrid1.Cells[ 7,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.AnomMoy;
         StringGrid1.Cells[ 8,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.ArgPer;
         StringGrid1.Cells[ 9,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.LongNod;
         StringGrid1.Cells[10,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.Inclin;
         StringGrid1.Cells[11,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.Excent ;
         StringGrid1.Cells[12,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.DGA;

{    SB_new.caption:=s;      }
       end;
       debut_actuel:=StringGrid1_debut;
    end;
end;

procedure TForm1.ButtonAucunFiltreClick(Sender: TObject);
var
   li : longint;
   s  : string;
begin
   CheckBoxH.Checked:=false;
   CheckBoxDiam.Checked:=false;
   CheckBoxIncl.Checked:=false;
   CheckBoxExc.Checked:=false;
   CheckBoxDGA.Checked:=false;
   Taille_liste_filtree:=Taille_liste;
   for li:=1 to Taille_liste do
      Liste_Filtree[li]:=li;

   str(Taille_liste,s);
   SB_Max.Caption:=s;
   Scrollbar1.Max:=Taille_liste;

   Update_StringGrid1;
end;

procedure TForm1.SetAppliquerFiltre;
begin
   ButtonAppliquerFiltre.Enabled:=CheckBoxH.Checked or
     CheckBoxDiam.Checked or CheckBoxIncl.Checked or
     CheckBoxExc.Checked  or CheckBoxDGA.Checked; 
end;

procedure TForm1.CheckBoxHClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxDiamClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxInclClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxExcClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxDGAClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.ButtonAppliquerFiltreClick(Sender: TObject);
var
   fli,li : longint;
   code : integer;
   ok,oks : boolean;
   s : string;
   FH,LH,Fdiam,Ldiam,FIncl,LIncl,FExc,LExc,FDGA,LDGA : real;
begin
   ButtonAppliquerFiltre.Caption:='Filtrage en cours...';
   ButtonAppliquerFiltre.Enabled:=false;

   val(FiltreH.Text,FH,code);
   val(FiltreDiam.Text,FDiam,code);
   val(FiltreIncl.text,FIncl,code);
   val(FiltreExc.Text,Fexc,code);
   val(FiltreDGA.Text,FDGA,code);

   fli:=0;

   for li:=1 to taille_liste do
   begin
      ok:=true;
      if CheckBoxH.Checked then
      begin
         val(liste[li]^.H,LH,code);
         oks:=FH < LH;
         if RadioButtonHSup.Checked then ok:=oks else ok:= not(oks);
      end;
      if CheckBoxDiam.Checked then
      begin
         val(liste[li]^.Diam,LDiam,code);
         oks:=FDiam < LDiam;
         if RadioButtonDiamSup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if CheckBoxIncl.Checked then
      begin
         val(liste[li]^.Inclin,LIncl,code);
         oks:=FIncl < LIncl;
         if RadioButtonInclSup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if CheckBoxExc.Checked then
      begin
         val(liste[li]^.Excent,LExc,code);
         oks:=FExc < LExc;
         if RadioButtonExcSup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if CheckBoxDGA.Checked then
      begin
         val(liste[li]^.DGA,LDGA,code);
         oks:=FDGA < LDGA;
         if RadioButtonDGASup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if ok then
      begin
         inc(fli);
         liste_filtree[fli]:=li;
      end;
   end;
   str(fli,s);
   label10.Caption:=s+' astrodes selectionns';
   Taille_liste_filtree:=fli;

   SB_Max.Caption:=s;
   Scrollbar1.Max:=Taille_liste_filtree;

   Update_StringGrid1;

   ButtonAppliquerFiltre.Caption:='Appliquer le filtre';
   ButtonAppliquerFiltre.Enabled:=true;
end;

procedure TForm1.ButtonFileMPCSeekClick(Sender: TObject);
begin
   Opendialog1.InitialDir:=ExtractFileDir(fichier_MPC.Text);
   if Opendialog1.Execute then
      If FileExists(Opendialog1.FileName) then
      begin
         fichier_MPC.Text:=Opendialog1.FileName;
         ButtonCreeBaseMPC.Enabled:=true;
      end
      else
      begin
         fichier_MPC.Text:='';
         ButtonCreeBaseMPC.Enabled:=false;
      end;
end;

procedure TForm1.ButtonCreeBaseMPCClick(Sender: TObject);
var
   astorb : textfile;
   buffer : string;
   compteur : longint;
   s,s1,s2  : string;
begin
   If FileExists(Fichier_MPC.text) then
   begin
      AssignFile(astorb,Fichier_MPC.text);
      Reset(astorb);

      { Passage de l'entete MPC }
      repeat
         readln(astorb,buffer);
      until copy(buffer,1,5)='-----';

      compteur:=0;
      repeat
         readln(astorb,buffer);
         if buffer<>'' then
         begin
            inc(compteur);
            new(liste[compteur]);
            with liste[compteur]^ do
            begin
               numero:=copy(buffer,1,7);
               str(compteur,s);
               nom:=copy(buffer,168,18);
               H:=copy(buffer,9,5);
               BMV:='';  {copy(buffer,54,4);}
               diam:=''; {copy(buffer,59,5);}
               IClass:=' '; {copy(buffer,65,4);}
               s1:=copy(buffer,106,4);
               s2:=copy(buffer,110,2);
               Epoque:=copy(buffer,112,2)+'/'+s2+'/'+s1;
               AnomMoy:=copy(buffer,27,9);
               ArgPer:=copy(buffer,38,9);
               LongNod:=copy(buffer,49,9);
               Inclin:= copy(buffer,60,9);
               Excent:= copy(buffer,71,9);
               DGA:=copy(buffer,93,11);
            end;
            Liste_Filtree[compteur]:=compteur;
         end;
      until eof(astorb);
      closefile(astorb);
      s:='';

      taille_liste:=compteur;
      taille_liste_filtree:=compteur;

      StringGrid1.RowCount:=1001;
      str(compteur,s);
      l_compteur.Caption:=s+' asteroides lus';
      SB_Max.Caption:=s;
      Orbite.TabVisible:=true;
      With Scrollbar1 do
      begin
         Max:=compteur;
         SmallChange:=1000;
      end;
      debut_actuel:=1;

      Update_StringGrid1;

      ButtonFileMPCSeek.Enabled:=false;
      ButtonCreeBaseMPC.Enabled:=false;
      ButtonFileLowellSeek.Enabled:=false;
      ButtonCreeBaseLowell.Enabled:=false; { Ainsi, si le fichier est lu, on ne peut plus
                                  recrer la liste }
      Orbite.Enabled:=true;
      Filtrage.Enabled:=true;
      StringGrid1.Visible:=true;

   end


end;

procedure TForm1.mise_a_jour_detail(objet_selectionne : longint);
var
   s : string;
   v,code : integer;
begin
   str(objet_selectionne,s);
   LabelSelection.Caption:=s;

   with  liste[objet_selectionne]^ do
   begin
       LabelVRang.Caption:=s;
       LabelVNom.caption:=nom;
       LabelVNumero.caption:=numero;
       LabelVH.caption:=H;
       LabelVBMV.caption:=BMV;
       LabelVDiam.caption:=Diam;
       LabelVClassIRAS.Caption:=IClass;
       LabelVEpoque.Caption:=Epoque;
       LabelVAnomMoy.Caption:=AnomMoy;
       LabelVArgPer.caption:=ArgPer;
       LabelVLongNod.Caption:=LongNod;
       LabelVInclin.Caption:=Inclin;
       LabelVExcent.Caption:=Excent;
       LabelVDGA.Caption:=DGA;

       val(code1,v,code);
       case v of
       0 : LabelVCode1.Caption:='';
       1 : LabelVCode1.Caption:='Aten asteroids (a<1.0 AU)';
       2 : LabelVCode1.Caption:='Apollo asteroids (a>1.0 AU; 0<q<1.0)';
       4 : LabelVCode1.Caption:='Amor asteroids (a>1.0167 AU; 1.0167<q < )';
       8 : LabelVCode1.Caption:='Mars crossers (1.3 < q < 1.6660 AU)';
       16: LabelVCode1.Caption:='Outer-planet crossers (excluding Jupiter and Mars Trojans)';
       else LabelVCode1.Caption:='Asteroids (excluding Mars and Jupiter Trojans) that cross both inner- and outer-planet orbits';
       end;

       val(code2,v,code);
       case v of
        1 : LabelVCode2.Caption:='Orbits derived from uncertainly, perhaps erroneously linked observations.';
        2 : LabelVCode2.Caption:='Eccentricity assumed';
        4 : LabelVCode2.Caption:='Eccentricity and semimajor axis assumed';
        8 : LabelVCode2.Caption:='Mainly for numbered asteroids, omitted observations have resulted in degradation of a so-called orbit-quality parameter, generally by more than 0.1. The corresponding ephemeris uncertainty has increased by about 25% or more';

        16: LabelVCode2.Caption:='OQP degrades by more than 0.1 if unsubstantiated observations (e.g., one-night apparitions) are omitted';
        32: LabelVCode2.Caption:='Orbit derived from data containing observations not in Minor Planet Center files';
        64: LabelVCode2.Caption:='H is unknown. H = 14 mag assumed';
       128: LabelVCode2.Caption:='Asteroid sought, but not found';
       else LabelVCode2.Caption:='';
       end;

       val(code3,v,code);
       case v of
       1 : LabelVCode3.Caption:='Palomar-Leiden survey (PLS) asteroids';
       2 : LabelVCode3.Caption:='Palomar-Leiden T-2 survey asteroids';
       4 : LabelVCode3.Caption:='Palomar-Leiden T-3 survey asteroids';
       8 : LabelVCode3.Caption:='U.K. Schmidt Telescope-Caltech asteroid survey (UCAS) asteroids';
       16: LabelVCode3.Caption:='Palomar-Leiden T-1 survey asteroids';
       else LabelVCode3.Caption:='Asteroids observed in more than one survey';
       end;

       val(code4,v,code);
       case v of
       1 : LabelVCode4.Caption:='Asteroide perdu';
       2 : LabelVCode4.Caption:='Asteroids observed at only two apparitions';
       3 : LabelVCode4.Caption:='Asteroids observed at only three apparitions';
       4 : LabelVCode4.Caption:='Asteroids observed at four or more apparitions, last more than ten years ago';
       5 : LabelVCode4.Caption:='Asteroids observed at four or more apparitions, only one night in last ten years';
       6 : LabelVCode4.Caption:='Other poorly observed asteroids observed at four or more apparitions';
       7 : LabelVCode4.Caption:='Absolute magnitude poorly known (not on MPC critical-list)';
       else LabelVCode4.Caption:='';
       end;

       val(code5,v,code);
       case v of
       1 : LabelVCode5.Caption:='Asteroids discovered by E. Bowell';
       2 : LabelVCode5.Caption:='Non-Bowell discoveries from Lowell search programs';
       3 : LabelVCode5.Caption:='Asteroid discovered jointly by E. Bowell and another person connected with Lowell search programs';
       else LabelVCode5.Caption:='';
       end;

       val(code6,v,code);
       case v of
       10 : LabelVCode6.Caption:='Exceptionally important, to be observed frequently. Principally space mission targets and occultation candidates';
        9 : LabelVCode6.Caption:='Asteroids useful for mass determination';
        8 : LabelVCode6.Caption:='Asteroids for which one or two additional nights observation are required to satisfy orbit-update requirements';
        7 : LabelVCode6.Caption:='Bowell unnumbered discoveries whose ephemeris uncertainties are less than 2 arcsec within the next ten years or so. MPC critical-list asteroids';
        6 : LabelVCode6.Caption:='Planet-crossers of type 6:5';
        5 : LabelVCode6.Caption:='Numbered asteroids whose ephemeris uncertainties are between 2 and 5 arcsec within the next ten years or so. Unnumbered asteroids that should be numberable after one or two more nights of obs.';
       else LabelVCode6.Caption:='';
       end;

{  {    ,Code6     }
   end;
end;


procedure TForm1.StringGrid1Click(Sender: TObject);
var
   myrect: TGridRect;
begin
   objet_selectionne:=Liste_filtree[debut_actuel+Stringgrid1.Row-1];
   with myRect do
   begin
      Left:=0; Right:=14;
      Top:=Stringgrid1.Row;
      Bottom:=Stringgrid1.Row;
   end;
   StringGrid1.Selection:=myrect;

{ Mise  jour de la page Dtails : }
   mise_a_jour_detail(objet_selectionne);
end;

procedure TForm1.ButtonFTPLowellClick(Sender: TObject);
begin
    Form2.Show;
end;

procedure TForm1.Recherche_asteroide(Cle : string;Taille : longint;
                              var resultat : longint;
                              var trouve   : boolean);
var
   premier,dernier,milieu : longint;
   arret                  : boolean;
   s                      : string;
begin
   milieu:=Taille div 2;
   premier:=1;
   dernier:=Taille;

   arret:=false;
   trouve:=false;
   resultat:=0;

   repeat
      Str(milieu,s);
      LMessage2.Caption:=s;
      if Table_Tri^[milieu].value<cle then premier:=milieu else dernier:=milieu;
      milieu:=(premier+dernier) div 2;
      if Table_Tri^[milieu].value=cle then trouve:=true
         else if (dernier-premier)<=2 then arret:=true;


   until trouve or arret;

   if trouve then
   begin
      resultat:=Table_Tri^[milieu].rang;
      Str(resultat,s);
      LMessage2.Caption:='Trouv au rang '+s;
   end else LMessage2.Caption:='Non trouv.';

end;

procedure TForm1.Button2Click(Sender: TObject);
var
   key : string;
   Trouve : boolean;
   Index  : longint;
begin
   Key:=Edit1.Text;
   Recherche_Asteroide(Key,Taille_Liste*2,index,Trouve);
   If trouve then
   begin
      Objet_selectionne:=Index;
      mise_a_jour_detail(objet_selectionne);
      TabSheet2.PageIndex:=5;
   end;
end;

procedure TForm1.VoirElements1Click(Sender: TObject);
var
   myrect: TGridRect;
begin
   objet_selectionne:=Liste_filtree[debut_actuel+Stringgrid1.Row-1];
   with myRect do
   begin
      Left:=0; Right:=14;
      Top:=Stringgrid1.Row;
      Bottom:=Stringgrid1.Row;
   end;
   StringGrid1.Selection:=myrect;

{ Mise  jour de la page Dtails : }
   mise_a_jour_detail(objet_selectionne);
   TabSheet2.PageIndex:=5;
end;

procedure TForm1.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   R,C : longint;
   myrect: TGridRect;
begin
   StringGrid1.MouseToCell(X,Y,C,R);
   objet_selectionne:=Liste_filtree[debut_actuel+R-1];
   with myRect do
   begin
      Left:=0; Right:=14;
      Top:=R;
      Bottom:=R;
   end;
   StringGrid1.Selection:=myrect;

{ Mise  jour de la page Dtails : }
   mise_a_jour_detail(objet_selectionne);

end;

procedure TForm1.Ajout_objet(objet : longint);
var
   s : string;
   i : longint;
   in_liste : boolean;
begin
   {Rechercher si l'objet n'est pas dj dans la liste}
   in_liste:=false;
   Str(objet,s);

   for i:=1 to objet_selectionne_liste do
      if StringGrid2.Cells[0,i]=s then in_liste:=true;
   if not in_liste then
   begin
      StringGrid2.RowCount:=StringGrid2.RowCount+1;
      StringGrid2.FixedRows:=1;
      StringGrid2.Cells[0,objet_selectionne_liste+1]:=s;
      StringGrid2.Cells[1,objet_selectionne_liste+1]:=liste[objet]^.numero;
      StringGrid2.Cells[2,objet_selectionne_liste+1]:=liste[objet]^.nom;
      inc(objet_selectionne_liste);
      BitBtnEffaceListe.Enabled:=True;
      BitBtnSauveListe.Enabled:=True;
   end;
end;

procedure TForm1.PopupTableClick(Sender: TObject);
begin
    { Ajouter l'lment slectionn par le menu popup1  la liste des astroides
      stocke dans StringGrid2}
    if objet_selectionne<>0 then
    begin
        Ajout_objet(objet_selectionne);
    end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
    { Ajouter l'objet 'objet_selectionne' dans StringGrid2 }
    if objet_selectionne<>0 then
    begin
        Ajout_objet(objet_selectionne);
    end;
end;

procedure TForm1.BitBtnEffaceListeClick(Sender: TObject);
begin
   objet_selectionne_liste:=0;
   StringGrid2.RowCount:=1;
   StringGrid2.FixedRows:=0;
   BitBtnEffaceListe.Enabled:=False;
   BitBtnSauveListe.Enabled:=False;
end;

procedure TForm1.BitBtnSauveListeClick(Sender: TObject);
var
   f        : textfile;
   scratch  : boolean;
   i,k,code : longint;
begin
   if objet_selectionne_liste>0 then
   begin
      Scratch:=true;
      If SaveDialog1.Execute then
      begin
         IF fileExists(savedialog1.FileName) then
            if MessageDlg('Voulez-vous craser le fichier existant ?',
                           mtConfirmation,[mbYes,mbNo],0,mbYes)<>mrYes then
               Scratch:=false;
         if scratch then
         begin
            Assignfile(f,SaveDialog1.FileName);
            Rewrite(f);
            for i:=1 to objet_selectionne_liste do
            begin
                Val(StringGrid2.Cells[0,i],k,code);
                with liste[k]^ do Writeln(f,nom,',',k,',',numero);
            end;
            closefile(f);
         end
      end;
   end
end;

procedure TForm1.StringGrid2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   R,C : longint;
   myrect: TGridRect;
begin
   StringGrid2.MouseToCell(X,Y,C,R);
   selection_objet_selectionne_liste:=R-1;
   with myRect do
   begin
      Left:=0; Right:=14;
      Top:=R;
      Bottom:=R;
   end;
   StringGrid2.Selection:=myrect;
end;

procedure TForm1.Up1Click(Sender: TObject);
var
   pos : longint;
   myrect: TGridRect;
   S1,S2,S3 : string;
begin
   myrect:=StringGrid2.Selection;
   pos:=myrect.Top;
   if pos>1 then
   begin
      S1:=StringGrid2.Cells[0,pos-1];
      S2:=StringGrid2.Cells[1,pos-1];
      S3:=StringGrid2.Cells[2,pos-1];
      StringGrid2.Cells[0,pos-1]:=StringGrid2.Cells[0,pos];
      StringGrid2.Cells[1,pos-1]:=StringGrid2.Cells[1,pos];
      StringGrid2.Cells[2,pos-1]:=StringGrid2.Cells[2,pos];
      StringGrid2.Cells[0,pos]:=S1;
      StringGrid2.Cells[1,pos]:=S2;
      StringGrid2.Cells[2,pos]:=S3;
      with myRect do
      begin
         Left:=0; Right:=2;
         Top:=pos-1;
         Bottom:=pos-1;
      end;
      StringGrid2.Selection:=myrect;
   end;
end;

procedure TForm1.Descendre1Click(Sender: TObject);
var
   pos : longint;
   myrect: TGridRect;
   S1,S2,S3 : string;
begin
   myrect:=StringGrid2.Selection;
   pos:=myrect.Top;
   if pos<objet_selectionne_liste then
   begin
      S1:=StringGrid2.Cells[0,pos+1];
      S2:=StringGrid2.Cells[1,pos+1];
      S3:=StringGrid2.Cells[2,pos+1];
      StringGrid2.Cells[0,pos+1]:=StringGrid2.Cells[0,pos];
      StringGrid2.Cells[1,pos+1]:=StringGrid2.Cells[1,pos];
      StringGrid2.Cells[2,pos+1]:=StringGrid2.Cells[2,pos];
      StringGrid2.Cells[0,pos]:=S1;
      StringGrid2.Cells[1,pos]:=S2;
      StringGrid2.Cells[2,pos]:=S3;
      with myRect do
      begin
         Left:=0; Right:=2;
         Top:=pos+1;
         Bottom:=pos+1;
      end;
      StringGrid2.Selection:=myrect;
   end;
end;

procedure TForm1.Effacer1Click(Sender: TObject);
var
   i,pos : longint;
   myrect: TGridRect;
   S1,S2,S3 : string;
begin
   myrect:=StringGrid2.Selection;
   pos:=myrect.Top;
   if pos>=1 then
   begin
      if pos=objet_selectionne_liste then
      begin
         StringGrid2.Cells[0,pos]:='';
         StringGrid2.Cells[1,pos]:='';
         StringGrid2.Cells[2,pos]:='';
      end
      else
      for i:=pos to objet_selectionne_liste-1 do
      begin
         S1:=StringGrid2.Cells[0,i+1];
         S2:=StringGrid2.Cells[1,i+1];
         S3:=StringGrid2.Cells[2,i+1];
         StringGrid2.Cells[0,i]:=S1;
         StringGrid2.Cells[1,i]:=S2;
         StringGrid2.Cells[2,i]:=S3;
      end;
      StringGrid2.Rowcount:=StringGrid2.Rowcount-1;
   end
end;

procedure TForm1.VoirElements2Click(Sender: TObject);
var
   myrect: TGridRect;
   objet,code : longint;
begin
   with myRect do
   begin
      Left:=0; Right:=2;
      Top:=Stringgrid2.Row;
      Bottom:=Stringgrid2.Row;
      Val(StringGrid2.Cells[0,Top],objet,code);
   end;
   StringGrid2.Selection:=myrect;

{ Mise  jour de la page Dtails : }
   mise_a_jour_detail(objet);
{   TabSheet2.PageIndex:=5;}
   PageControl1.ActivePage:=TabSheet2;
end;

procedure TForm1.StringGrid2Click(Sender: TObject);
var
   myrect: TGridRect;
begin
   with myRect do
   begin
      Left:=0; Right:=3;
      Top:=Stringgrid2.Row;
      Bottom:=Stringgrid2.Row;
   end;
   StringGrid2.Selection:=myrect;
end;

procedure TForm1.BUpClick(Sender: TObject);
begin
   Up1Click(Sender)
end;

procedure TForm1.BDownClick(Sender: TObject);
begin
   Descendre1Click(Sender);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
   Effacer1Click(Sender);
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
   VoirElements2Click(Sender);
end;

end.
